function [Hx,LfHx,Lf2Hx,LgLfHx]= hx_and_derivatives(q,dq,a,theta_minus,theta_plus)
%%
%%
%%  HX_AND_DERIVATIVES
%%
%%
%%  03-Dec-2003 17:18:26
%%
%%
%% Author(s): Ben Morris and Jessy Grizzle
%%
%%
[r,m,Mh,Mt,L,g]=model_params;
%%
%%
q1=q(1);q2=q(2);q3=q(3);
dq1=dq(1);dq2=dq(2);dq3=dq(3);
%%
%%
a0_q2 = a(1,1); a1_q2 = a(1,2); a2_q2 = a(1,3); a3_q2 = a(1,4); a4_q2 = a(1,5);
a0_q3 = a(2,1); a1_q3 = a(2,2); a2_q3 = a(2,3); a3_q3 = a(2,4); a4_q3 = a(2,5);
%%
 
Hx(1,1)=-(-4*a3_q2*q1^4+a4_q2*q1^4+a4_q2*theta_plus^4-12*a1_q2* ...
         theta_plus*theta_minus^2*q1-12*a1_q2*theta_plus*theta_minus*q1^2+ ...
         12*a2_q2*theta_plus*theta_minus^2*q1+24*a2_q2*theta_plus* ...
         theta_minus*q1^2+12*a2_q2*theta_plus^2*theta_minus*q1-12*a3_q2* ...
         theta_plus*theta_minus*q1^2-12*a3_q2*theta_plus^2*theta_minus*q1+ ...
         4*q2*theta_minus^3*theta_plus-6*q2*theta_minus^2*theta_plus^2+4* ...
         q2*theta_minus*theta_plus^3+4*a0_q2*theta_minus^3*q1+6*a0_q2* ...
         theta_minus^2*q1^2+4*a0_q2*theta_minus*q1^3-4*a1_q2* ...
         theta_minus^3*q1-12*a1_q2*theta_minus^2*q1^2-12*a1_q2* ...
         theta_minus*q1^3-4*a1_q2*theta_minus^3*theta_plus-4*a1_q2* ...
         theta_plus*q1^3+6*a2_q2*theta_minus^2*q1^2+12*a2_q2*theta_minus* ...
         q1^3+12*a2_q2*theta_plus*q1^3+6*a2_q2*theta_minus^2*theta_plus^2+ ...
         6*a2_q2*theta_plus^2*q1^2-q2*theta_minus^4-q2*theta_plus^4+a0_q2* ...
         theta_minus^4+a0_q2*q1^4-4*a1_q2*q1^4+6*a2_q2*q1^4-4*a3_q2* ...
         theta_minus*q1^3-12*a3_q2*theta_plus*q1^3-12*a3_q2*theta_plus^2* ...
         q1^2-4*a3_q2*theta_minus*theta_plus^3-4*a3_q2*theta_plus^3*q1+4* ...
         a4_q2*theta_plus*q1^3+6*a4_q2*theta_plus^2*q1^2+4*a4_q2* ...
         theta_plus^3*q1)/(theta_minus-theta_plus)^4;
Hx(2,1)=(-4*q3*theta_minus^3*theta_plus+6*q3*theta_minus^2* ...
         theta_plus^2-4*q3*theta_minus*theta_plus^3-4*a0_q3*theta_minus^3* ...
         q1-6*a0_q3*theta_minus^2*q1^2-4*a0_q3*theta_minus*q1^3+4*a1_q3* ...
         theta_minus^3*q1+12*a1_q3*theta_minus^2*q1^2-a4_q3*q1^4-a4_q3* ...
         theta_plus^4+12*a1_q3*theta_plus*theta_minus^2*q1+12*a1_q3* ...
         theta_plus*theta_minus*q1^2-12*a2_q3*theta_plus*theta_minus^2*q1- ...
         24*a2_q3*theta_plus*theta_minus*q1^2-12*a2_q3*theta_plus^2* ...
         theta_minus*q1+12*a3_q3*theta_plus*theta_minus*q1^2+12*a3_q3* ...
         theta_plus^2*theta_minus*q1+q3*theta_minus^4+q3*theta_plus^4- ...
         a0_q3*theta_minus^4-a0_q3*q1^4+4*a1_q3*q1^4-6*a2_q3*q1^4+12* ...
         a1_q3*theta_minus*q1^3+4*a1_q3*theta_minus^3*theta_plus+4*a1_q3* ...
         theta_plus*q1^3-6*a2_q3*theta_minus^2*q1^2-12*a2_q3*theta_minus* ...
         q1^3-12*a2_q3*theta_plus*q1^3-6*a2_q3*theta_minus^2*theta_plus^2- ...
         6*a2_q3*theta_plus^2*q1^2+4*a3_q3*theta_minus*q1^3+12*a3_q3* ...
         theta_plus*q1^3+12*a3_q3*theta_plus^2*q1^2+4*a3_q3*theta_minus* ...
         theta_plus^3+4*a3_q3*theta_plus^3*q1-4*a4_q3*theta_plus*q1^3-6* ...
         a4_q3*theta_plus^2*q1^2-4*a4_q3*theta_plus^3*q1+4*a3_q3* ...
         q1^4)/(theta_minus-theta_plus)^4;
 
LfHx(1,1)=-(4*a0_q2*theta_minus^3+12*a0_q2*theta_minus^2*q1+12* ...
         a0_q2*theta_minus*q1^2-4*a1_q2*theta_minus^3-24*a1_q2* ...
         theta_minus^2*q1-36*a1_q2*theta_minus*q1^2+12*a2_q2* ...
         theta_minus^2*q1+36*a2_q2*theta_minus*q1^2-12*a3_q2*theta_minus* ...
         q1^2+12*a4_q2*theta_plus*q1^2+12*a4_q2*theta_plus^2*q1+4*a4_q2* ...
         theta_plus^3+4*a4_q2*q1^3+4*a0_q2*q1^3-16*a1_q2*q1^3+24*a2_q2* ...
         q1^3-16*a3_q2*q1^3-4*a3_q2*theta_plus^3+12*a2_q2*theta_plus* ...
         theta_minus^2+48*a2_q2*theta_plus*theta_minus*q1+12*a2_q2* ...
         theta_plus^2*theta_minus-24*a3_q2*theta_plus*theta_minus*q1-12* ...
         a3_q2*theta_plus^2*theta_minus-12*a1_q2*theta_plus*q1^2-12*a1_q2* ...
         theta_plus*theta_minus^2-24*a1_q2*theta_plus*theta_minus*q1+12* ...
         a2_q2*theta_plus^2*q1-36*a3_q2*theta_plus*q1^2-24*a3_q2* ...
         theta_plus^2*q1+36*a2_q2*theta_plus*q1^2)/(theta_minus- ...
         theta_plus)^4*dq1-(4*theta_minus^3*theta_plus-6*theta_minus^2* ...
         theta_plus^2+4*theta_minus*theta_plus^3-theta_minus^4- ...
         theta_plus^4)/(theta_minus-theta_plus)^4*dq2;
LfHx(2,1)=(12*a1_q3*theta_plus*q1^2-36*a2_q3*theta_plus*q1^2-4* ...
         a0_q3*q1^3-12*a2_q3*theta_plus^2*q1+36*a3_q3*theta_plus*q1^2+24* ...
         a3_q3*theta_plus^2*q1+16*a1_q3*q1^3-24*a2_q3*q1^3+16*a3_q3*q1^3+ ...
         4*a3_q3*theta_plus^3+24*a1_q3*theta_plus*theta_minus*q1-12*a2_q3* ...
         theta_plus*theta_minus^2-48*a2_q3*theta_plus*theta_minus*q1-12* ...
         a2_q3*theta_plus^2*theta_minus+24*a3_q3*theta_plus*theta_minus* ...
         q1+12*a3_q3*theta_plus^2*theta_minus-4*a0_q3*theta_minus^3-12* ...
         a0_q3*theta_minus^2*q1-12*a0_q3*theta_minus*q1^2+4*a1_q3* ...
         theta_minus^3+24*a1_q3*theta_minus^2*q1+36*a1_q3*theta_minus* ...
         q1^2-12*a2_q3*theta_minus^2*q1-36*a2_q3*theta_minus*q1^2+12* ...
         a1_q3*theta_plus*theta_minus^2-4*a4_q3*q1^3+12*a3_q3*theta_minus* ...
         q1^2-12*a4_q3*theta_plus*q1^2-12*a4_q3*theta_plus^2*q1-4*a4_q3* ...
         theta_plus^3)/(theta_minus-theta_plus)^4*dq1+(theta_minus^4-4* ...
         theta_minus^3*theta_plus+6*theta_minus^2*theta_plus^2-4* ...
         theta_minus*theta_plus^3+theta_plus^4)/(theta_minus- ...
         theta_plus)^4*dq3;
 
Lf2Hx(1,1)=-(12*a0_q2*theta_minus^2+24*a0_q2*theta_minus*q1-24* ...
         a1_q2*theta_minus^2-72*a1_q2*theta_minus*q1+12*a2_q2* ...
         theta_minus^2+72*a2_q2*theta_minus*q1-24*a3_q2*theta_minus*q1+24* ...
         a4_q2*theta_plus*q1+12*theta_plus^2*a4_q2+12*a4_q2*q1^2+12*a0_q2* ...
         q1^2-48*a1_q2*q1^2+72*a2_q2*q1^2-48*a3_q2*q1^2+48*a2_q2* ...
         theta_plus*theta_minus-24*a3_q2*theta_plus*theta_minus-24*a1_q2* ...
         theta_plus*q1-24*a1_q2*theta_plus*theta_minus+12*a2_q2* ...
         theta_plus^2-72*a3_q2*theta_plus*q1-24*a3_q2*theta_plus^2+72* ...
         a2_q2*theta_plus*q1)/(theta_minus-theta_plus)^4*dq1^2-(4*a0_q2* ...
         theta_minus^3+12*a0_q2*theta_minus^2*q1+12*a0_q2*theta_minus* ...
         q1^2-4*a1_q2*theta_minus^3-24*a1_q2*theta_minus^2*q1-36*a1_q2* ...
         theta_minus*q1^2+12*a2_q2*theta_minus^2*q1+36*a2_q2*theta_minus* ...
         q1^2-12*a3_q2*theta_minus*q1^2+12*a4_q2*theta_plus*q1^2+12*a4_q2* ...
         theta_plus^2*q1+4*a4_q2*theta_plus^3+4*a4_q2*q1^3+4*a0_q2*q1^3- ...
         16*a1_q2*q1^3+24*a2_q2*q1^3-16*a3_q2*q1^3-4*a3_q2*theta_plus^3+ ...
         12*a2_q2*theta_plus*theta_minus^2+48*a2_q2*theta_plus* ...
         theta_minus*q1+12*a2_q2*theta_plus^2*theta_minus-24*a3_q2* ...
         theta_plus*theta_minus*q1-12*a3_q2*theta_plus^2*theta_minus-12* ...
         a1_q2*theta_plus*q1^2-12*a1_q2*theta_plus*theta_minus^2-24*a1_q2* ...
         theta_plus*theta_minus*q1+12*a2_q2*theta_plus^2*q1-36*a3_q2* ...
         theta_plus*q1^2-24*a3_q2*theta_plus^2*q1+36*a2_q2*theta_plus* ...
         q1^2)/(theta_minus-theta_plus)^4*(-4/r^2/(-5*m-4*Mh-4*Mt+4*m* ...
         cos(q2)^2+4*Mt*cos(q3)^2)*(1/2*r*(m*sin(q2)*r*dq2+2*Mt*L*sin(q3)* ...
         dq3)*dq1+1/2*m*sin(q2)*r^2*(dq1+dq2)*dq2+Mt*r*L*sin(q3)*(dq1+ ...
         dq3)*dq3-1/2*g*(2*Mh*cos(q1)+m*cos(q1+q2)+2*Mt*cos(q1)+3*m* ...
         cos(q1))*r-g*Mt*L*cos(q1+q3))+4*(2*cos(q2)+1)/r^2/(-5*m-4*Mh-4* ...
         Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)*(-1/2*m*sin(q2)*r^2*dq1^2-1/2*g* ...
         m*r*cos(q1+q2))+4/r^2/L*(r*cos(q3)+L)/(-5*m-4*Mh-4*Mt+4*m* ...
         cos(q2)^2+4*Mt*cos(q3)^2)*(-Mt*r*L*sin(q3)*dq1^2-g*Mt*L*cos(q1+ ...
         q3)))-(4*theta_minus^3*theta_plus-6*theta_minus^2*theta_plus^2+4* ...
         theta_minus*theta_plus^3-theta_minus^4- ...
         theta_plus^4)/(theta_minus-theta_plus)^4*(4*(2*cos(q2)+1)/r^2/(- ...
         5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)*(1/2*r*(m*sin(q2)*r* ...
         dq2+2*Mt*L*sin(q3)*dq3)*dq1+1/2*m*sin(q2)*r^2*(dq1+dq2)*dq2+Mt*r* ...
         L*sin(q3)*(dq1+dq3)*dq3-1/2*g*(2*Mh*cos(q1)+m*cos(q1+q2)+2*Mt* ...
         cos(q1)+3*m*cos(q1))*r-g*Mt*L*cos(q1+q3))-8/r^2*(3*m+2*Mh+2*m* ...
         cos(q2)+2*Mt-2*Mt*cos(q3)^2)/m/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4* ...
         Mt*cos(q3)^2)*(-1/2*m*sin(q2)*r^2*dq1^2-1/2*g*m*r*cos(q1+q2))- ...
         4/L*(r*cos(q3)+L)/r^2*(2*cos(q2)+1)/(-5*m-4*Mh-4*Mt+4*m* ...
         cos(q2)^2+4*Mt*cos(q3)^2)*(-Mt*r*L*sin(q3)*dq1^2-g*Mt*L*cos(q1+ ...
         q3)));
Lf2Hx(2,1)=(24*a1_q3*theta_plus*q1-72*a2_q3*theta_plus*q1-12* ...
         a0_q3*q1^2-12*a2_q3*theta_plus^2+72*a3_q3*theta_plus*q1+24*a3_q3* ...
         theta_plus^2+48*a1_q3*q1^2-72*a2_q3*q1^2+48*a3_q3*q1^2+24*a1_q3* ...
         theta_plus*theta_minus-48*a2_q3*theta_plus*theta_minus+24*a3_q3* ...
         theta_plus*theta_minus-12*a0_q3*theta_minus^2-24*a0_q3* ...
         theta_minus*q1+24*a1_q3*theta_minus^2+72*a1_q3*theta_minus*q1-12* ...
         a2_q3*theta_minus^2-72*a2_q3*theta_minus*q1-12*a4_q3*q1^2+24* ...
         a3_q3*theta_minus*q1-24*a4_q3*theta_plus*q1-12*a4_q3* ...
         theta_plus^2)/(theta_minus-theta_plus)^4*dq1^2+(12*a1_q3* ...
         theta_plus*q1^2-36*a2_q3*theta_plus*q1^2-4*a0_q3*q1^3-12*a2_q3* ...
         theta_plus^2*q1+36*a3_q3*theta_plus*q1^2+24*a3_q3*theta_plus^2* ...
         q1+16*a1_q3*q1^3-24*a2_q3*q1^3+16*a3_q3*q1^3+4*a3_q3* ...
         theta_plus^3+24*a1_q3*theta_plus*theta_minus*q1-12*a2_q3* ...
         theta_plus*theta_minus^2-48*a2_q3*theta_plus*theta_minus*q1-12* ...
         a2_q3*theta_plus^2*theta_minus+24*a3_q3*theta_plus*theta_minus* ...
         q1+12*a3_q3*theta_plus^2*theta_minus-4*a0_q3*theta_minus^3-12* ...
         a0_q3*theta_minus^2*q1-12*a0_q3*theta_minus*q1^2+4*a1_q3* ...
         theta_minus^3+24*a1_q3*theta_minus^2*q1+36*a1_q3*theta_minus* ...
         q1^2-12*a2_q3*theta_minus^2*q1-36*a2_q3*theta_minus*q1^2+12* ...
         a1_q3*theta_plus*theta_minus^2-4*a4_q3*q1^3+12*a3_q3*theta_minus* ...
         q1^2-12*a4_q3*theta_plus*q1^2-12*a4_q3*theta_plus^2*q1-4*a4_q3* ...
         theta_plus^3)/(theta_minus-theta_plus)^4*(-4/r^2/(-5*m-4*Mh-4*Mt+ ...
         4*m*cos(q2)^2+4*Mt*cos(q3)^2)*(1/2*r*(m*sin(q2)*r*dq2+2*Mt*L* ...
         sin(q3)*dq3)*dq1+1/2*m*sin(q2)*r^2*(dq1+dq2)*dq2+Mt*r*L*sin(q3)* ...
         (dq1+dq3)*dq3-1/2*g*(2*Mh*cos(q1)+m*cos(q1+q2)+2*Mt*cos(q1)+3*m* ...
         cos(q1))*r-g*Mt*L*cos(q1+q3))+4*(2*cos(q2)+1)/r^2/(-5*m-4*Mh-4* ...
         Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)*(-1/2*m*sin(q2)*r^2*dq1^2-1/2*g* ...
         m*r*cos(q1+q2))+4/r^2/L*(r*cos(q3)+L)/(-5*m-4*Mh-4*Mt+4*m* ...
         cos(q2)^2+4*Mt*cos(q3)^2)*(-Mt*r*L*sin(q3)*dq1^2-g*Mt*L*cos(q1+ ...
         q3)))+(theta_minus^4-4*theta_minus^3*theta_plus+6*theta_minus^2* ...
         theta_plus^2-4*theta_minus*theta_plus^3+ ...
         theta_plus^4)/(theta_minus-theta_plus)^4*(4/r^2/L*(r*cos(q3)+ ...
         L)/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)*(1/2*r*(m* ...
         sin(q2)*r*dq2+2*Mt*L*sin(q3)*dq3)*dq1+1/2*m*sin(q2)*r^2*(dq1+ ...
         dq2)*dq2+Mt*r*L*sin(q3)*(dq1+dq3)*dq3-1/2*g*(2*Mh*cos(q1)+m* ...
         cos(q1+q2)+2*Mt*cos(q1)+3*m*cos(q1))*r-g*Mt*L*cos(q1+q3))-4/L*(r* ...
         cos(q3)+L)/r^2*(2*cos(q2)+1)/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt* ...
         cos(q3)^2)*(-1/2*m*sin(q2)*r^2*dq1^2-1/2*g*m*r*cos(q1+q2))+1/r^2* ...
         (-5*m*r^2-4*Mh*r^2-4*Mt*r^2-8*Mt*r*L*cos(q3)-4*Mt*L^2+4*r^2*m* ...
         cos(q2)^2)/Mt/L^2/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)* ...
         (-Mt*r*L*sin(q3)*dq1^2-g*Mt*L*cos(q1+q3)));
 
LgLfHx(1,1)=-4*(4*a0_q2*theta_minus^3+12*a0_q2*theta_minus^2*q1+ ...
         12*a0_q2*theta_minus*q1^2-4*a1_q2*theta_minus^3-24*a1_q2* ...
         theta_minus^2*q1-36*a1_q2*theta_minus*q1^2+12*a2_q2* ...
         theta_minus^2*q1+36*a2_q2*theta_minus*q1^2-12*a3_q2*theta_minus* ...
         q1^2+12*a4_q2*theta_plus*q1^2+12*a4_q2*theta_plus^2*q1+4*a4_q2* ...
         theta_plus^3+4*a4_q2*q1^3+4*a0_q2*q1^3-16*a1_q2*q1^3+24*a2_q2* ...
         q1^3-16*a3_q2*q1^3-4*a3_q2*theta_plus^3+12*a2_q2*theta_plus* ...
         theta_minus^2+48*a2_q2*theta_plus*theta_minus*q1+12*a2_q2* ...
         theta_plus^2*theta_minus-24*a3_q2*theta_plus*theta_minus*q1-12* ...
         a3_q2*theta_plus^2*theta_minus-12*a1_q2*theta_plus*q1^2-12*a1_q2* ...
         theta_plus*theta_minus^2-24*a1_q2*theta_plus*theta_minus*q1+12* ...
         a2_q2*theta_plus^2*q1-36*a3_q2*theta_plus*q1^2-24*a3_q2* ...
         theta_plus^2*q1+36*a2_q2*theta_plus*q1^2)/(theta_minus- ...
         theta_plus)^4*(2*cos(q2)+1)/r^2/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4* ...
         Mt*cos(q3)^2)+8*(4*theta_minus^3*theta_plus-6*theta_minus^2* ...
         theta_plus^2+4*theta_minus*theta_plus^3-theta_minus^4- ...
         theta_plus^4)/(theta_minus-theta_plus)^4/r^2*(3*m+2*Mh+2*m* ...
         cos(q2)+2*Mt-2*Mt*cos(q3)^2)/m/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4* ...
         Mt*cos(q3)^2);
LgLfHx(1,2)=-4*(4*a0_q2*theta_minus^3+12*a0_q2*theta_minus^2*q1+ ...
         12*a0_q2*theta_minus*q1^2-4*a1_q2*theta_minus^3-24*a1_q2* ...
         theta_minus^2*q1-36*a1_q2*theta_minus*q1^2+12*a2_q2* ...
         theta_minus^2*q1+36*a2_q2*theta_minus*q1^2-12*a3_q2*theta_minus* ...
         q1^2+12*a4_q2*theta_plus*q1^2+12*a4_q2*theta_plus^2*q1+4*a4_q2* ...
         theta_plus^3+4*a4_q2*q1^3+4*a0_q2*q1^3-16*a1_q2*q1^3+24*a2_q2* ...
         q1^3-16*a3_q2*q1^3-4*a3_q2*theta_plus^3+12*a2_q2*theta_plus* ...
         theta_minus^2+48*a2_q2*theta_plus*theta_minus*q1+12*a2_q2* ...
         theta_plus^2*theta_minus-24*a3_q2*theta_plus*theta_minus*q1-12* ...
         a3_q2*theta_plus^2*theta_minus-12*a1_q2*theta_plus*q1^2-12*a1_q2* ...
         theta_plus*theta_minus^2-24*a1_q2*theta_plus*theta_minus*q1+12* ...
         a2_q2*theta_plus^2*q1-36*a3_q2*theta_plus*q1^2-24*a3_q2* ...
         theta_plus^2*q1+36*a2_q2*theta_plus*q1^2)/(theta_minus- ...
         theta_plus)^4/r^2/L*(r*cos(q3)+L)/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+ ...
         4*Mt*cos(q3)^2)+4*(4*theta_minus^3*theta_plus-6*theta_minus^2* ...
         theta_plus^2+4*theta_minus*theta_plus^3-theta_minus^4- ...
         theta_plus^4)/(theta_minus-theta_plus)^4/L*(r*cos(q3)+L)/r^2*(2* ...
         cos(q2)+1)/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2);
LgLfHx(2,1)=4*(12*a1_q3*theta_plus*q1^2-36*a2_q3*theta_plus*q1^2- ...
         4*a0_q3*q1^3-12*a2_q3*theta_plus^2*q1+36*a3_q3*theta_plus*q1^2+ ...
         24*a3_q3*theta_plus^2*q1+16*a1_q3*q1^3-24*a2_q3*q1^3+16*a3_q3* ...
         q1^3+4*a3_q3*theta_plus^3+24*a1_q3*theta_plus*theta_minus*q1-12* ...
         a2_q3*theta_plus*theta_minus^2-48*a2_q3*theta_plus*theta_minus* ...
         q1-12*a2_q3*theta_plus^2*theta_minus+24*a3_q3*theta_plus* ...
         theta_minus*q1+12*a3_q3*theta_plus^2*theta_minus-4*a0_q3* ...
         theta_minus^3-12*a0_q3*theta_minus^2*q1-12*a0_q3*theta_minus* ...
         q1^2+4*a1_q3*theta_minus^3+24*a1_q3*theta_minus^2*q1+36*a1_q3* ...
         theta_minus*q1^2-12*a2_q3*theta_minus^2*q1-36*a2_q3*theta_minus* ...
         q1^2+12*a1_q3*theta_plus*theta_minus^2-4*a4_q3*q1^3+12*a3_q3* ...
         theta_minus*q1^2-12*a4_q3*theta_plus*q1^2-12*a4_q3*theta_plus^2* ...
         q1-4*a4_q3*theta_plus^3)/(theta_minus-theta_plus)^4*(2*cos(q2)+ ...
         1)/r^2/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)-4* ...
         (theta_minus^4-4*theta_minus^3*theta_plus+6*theta_minus^2* ...
         theta_plus^2-4*theta_minus*theta_plus^3+ ...
         theta_plus^4)/(theta_minus-theta_plus)^4/L*(r*cos(q3)+L)/r^2*(2* ...
         cos(q2)+1)/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2);
LgLfHx(2,2)=4*(12*a1_q3*theta_plus*q1^2-36*a2_q3*theta_plus*q1^2- ...
         4*a0_q3*q1^3-12*a2_q3*theta_plus^2*q1+36*a3_q3*theta_plus*q1^2+ ...
         24*a3_q3*theta_plus^2*q1+16*a1_q3*q1^3-24*a2_q3*q1^3+16*a3_q3* ...
         q1^3+4*a3_q3*theta_plus^3+24*a1_q3*theta_plus*theta_minus*q1-12* ...
         a2_q3*theta_plus*theta_minus^2-48*a2_q3*theta_plus*theta_minus* ...
         q1-12*a2_q3*theta_plus^2*theta_minus+24*a3_q3*theta_plus* ...
         theta_minus*q1+12*a3_q3*theta_plus^2*theta_minus-4*a0_q3* ...
         theta_minus^3-12*a0_q3*theta_minus^2*q1-12*a0_q3*theta_minus* ...
         q1^2+4*a1_q3*theta_minus^3+24*a1_q3*theta_minus^2*q1+36*a1_q3* ...
         theta_minus*q1^2-12*a2_q3*theta_minus^2*q1-36*a2_q3*theta_minus* ...
         q1^2+12*a1_q3*theta_plus*theta_minus^2-4*a4_q3*q1^3+12*a3_q3* ...
         theta_minus*q1^2-12*a4_q3*theta_plus*q1^2-12*a4_q3*theta_plus^2* ...
         q1-4*a4_q3*theta_plus^3)/(theta_minus-theta_plus)^4/r^2/L*(r* ...
         cos(q3)+L)/(-5*m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2)+ ...
         (theta_minus^4-4*theta_minus^3*theta_plus+6*theta_minus^2* ...
         theta_plus^2-4*theta_minus*theta_plus^3+ ...
         theta_plus^4)/(theta_minus-theta_plus)^4/r^2*(-5*m*r^2-4*Mh*r^2- ...
         4*Mt*r^2-8*Mt*r*L*cos(q3)-4*Mt*L^2+4*r^2*m*cos(q2)^2)/Mt/L^2/(-5* ...
         m-4*Mh-4*Mt+4*m*cos(q2)^2+4*Mt*cos(q3)^2);
return